unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TMainForm = class(TForm)
    BCapture: TButton;
    LText: TLabel;
    EText: TEdit;
    ApplyText: TButton;
    LSize: TLabel;
    ESize: TComboBox;
    ApplySize: TButton;
    LPos: TLabel;
    BPos: TButton;
    PChild1: TPanel;
    EOnTop: TCheckBox;
    BCloseWindow: TButton;
    PChild2: TPanel;
    BWinList: TButton;
    BClose: TButton;
    procedure BCaptureClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ApplyTextClick(Sender: TObject);
    procedure ApplySizeClick(Sender: TObject);
    procedure EOnTopClick(Sender: TObject);
    procedure BCloseWindowClick(Sender: TObject);
    procedure BPosClick(Sender: TObject);
    procedure BCloseClick(Sender: TObject);
    procedure BWinListClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    hwnd:THandle;
    procedure UpdateInfo;
  end;

var
  MainForm: TMainForm;

type str9=string[9];
function tohex(i:integer):str9;
function toasc(i:integer):str9;

implementation

uses Capture, SetPos, PickWin;

{$R *.dfm}

function tohex(i:integer):str9;
const hex:string[19]='0123456789ABCDEF';
begin
  tohex:=hex[((i SHR 28) AND 15)+1]+hex[((i SHR 24) AND 15)+1]+
         hex[((i SHR 20) AND 15)+1]+hex[((i SHR 16) AND 15)+1]+
         hex[((i SHR 12) AND 15)+1]+hex[((i SHR  8) AND 15)+1]+
         hex[((i SHR  4) AND 15)+1]+hex[( i         AND 15)+1];
end;

function toasc(i:integer):str9;
const hex:string[19]='0123456789ABCDEF';
begin
  toasc:=char((i SHR 28) AND 15 OR 64)+char((i SHR 24) AND 15 OR 64)+
         char((i SHR 20) AND 15 OR 64)+char((i SHR 16) AND 15 OR 64)+
         char((i SHR 12) AND 15 OR 64)+char((i SHR  8) AND 15 OR 64)+
         char((i SHR  4) AND 15 OR 64)+char( i         AND 15 OR 64);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
//AllocConsole;
  hwnd:=0;
end;

procedure TMainForm.BCaptureClick(Sender: TObject);
begin
  Hide;
  CaptureForm.ShowModal;
  hwnd:=WindowFromPoint(CaptureForm.Clicked);
  UpdateInfo; Show;
end;

procedure TMainForm.UpdateInfo;
var CapBuf:array[0..2047]of char;
    IsChild:boolean;
    Rect:TRect;
    SX,SY:integer;
begin
  if hwnd=0 then begin
    Caption:='WinProps';
    EText.Text:='< kein Fenster ausgewhlt >'; EText.Enabled:=false; ApplyText.Enabled:=false;
    ESize.Text:='0x0'; ESize.Enabled:=false; ApplySize.Enabled:=false;
    BPos.Caption:='0,0'; BPos.Enabled:=false;
    EOnTop.Checked:=false; EOnTop.Enabled:=false;
    BCloseWindow.Enabled:=false;
  end else begin
    Caption:='WinProps - 0x'+tohex(hwnd);
    SendMessage(hwnd,WM_GETTEXT,2048,integer(@CapBuf[0])); CapBuf[2047]:=#0;
    EText.Text:=PChar(@CapBuf[0]); EText.Enabled:=true; ApplyText.Enabled:=true;
    IsChild:=(GetParent(hwnd)<>0); PChild1.Visible:=IsChild; PChild2.Visible:=IsChild;
    GetWindowRect(hwnd,Rect);
    SX:=Rect.Right-Rect.Left; SY:=Rect.Bottom-Rect.Top;
    ESize.Text:=IntToStr(SX)+'x'+IntToStr(SY); ESize.Items[0]:=ESize.Text;
    ESize.Enabled:=not(IsChild); ApplySize.Enabled:=not(IsChild);
    BPos.Caption:=IntToStr(Rect.Left)+','+IntToStr(Rect.Top); BPos.Enabled:=not(IsChild);
    if not(IsChild) then EOnTop.Checked:=(GetWindowLong(hwnd,GWL_EXSTYLE) AND WS_EX_TOPMOST<>0);
    EOnTop.Enabled:=not(IsChild); BCloseWindow.Enabled:=not(IsChild);
  end;
end;

procedure TMainForm.ApplyTextClick(Sender: TObject);
var CapBuf:PChar;
begin
  if hwnd=0 then exit;
  CapBuf:=PChar(EText.Text);
  SendMessage(hwnd,WM_SETTEXT,0,integer(@CapBuf[0]));
end;

procedure TMainForm.ApplySizeClick(Sender: TObject);
var s:string[9]; xpos:integer; SX,SY,r:integer;
begin
  if hwnd=0 then exit;
  if length(ESize.Text)>9 then begin Beep;exit;end;
  s:=ESize.Text;
  xpos:=pos('x',s); if (xpos<2) OR (xpos>length(s)-1) then begin Beep;exit;end;
  val(copy(s,1,xpos-1),SX,r); if (r<>0) then begin Beep;exit;end;
  val(copy(s,xpos+1,4),SY,r); if (r<>0) then begin Beep;exit;end;
  SetWindowPos(hwnd,0,0,0,SX,SY,SWP_NOMOVE OR SWP_NOZORDER);
end;

procedure TMainForm.EOnTopClick(Sender: TObject);
begin
  if hwnd=0 then exit;
  if EOnTop.Checked
    then SetWindowPos(hwnd,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE)
    else SetWindowPos(hwnd,HWND_NOTOPMOST,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE);
end;

procedure TMainForm.BCloseWindowClick(Sender: TObject);
begin
  if hwnd=0 then exit;
  if MessageDlg('Zielfenster wirklich schlieen?'^M^M+
                'HINWEIS: Es handelt sich bei dem zu schlieenden Fenster NICHT'^M+
                'um WinProps, sondern um das Zielfenster!',mtConfirmation,
                [mbYes,mbNo],0)<>mrYes then exit;
  PostMessage(hwnd,WM_CLOSE,0,0);
end;

procedure TMainForm.BPosClick(Sender: TObject);
var Rect:TRect;
begin
  if hwnd=0 then exit;
  with SetPosForm do begin
    GetWindowRect(hwnd,Rect);
    SX:=Rect.Right-Rect.Left; SY:=Rect.Bottom-Rect.Top;
    if ShowModal=mrCancel then exit;
    SetWindowPos(hwnd,0,NX,NY,0,0,SWP_NOSIZE OR SWP_NOZORDER);
  end;
end;

procedure TMainForm.BCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.BWinListClick(Sender: TObject);
begin
  if PickWinForm.ShowModal=mrCancel then exit;
  hwnd:=PickWinForm.hwnd; UpdateInfo;
end;

end.
