unit PickWin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TPickWinForm = class(TForm)
    WinList: TListBox;
    BClose: TButton;
    BSelect: TButton;
    procedure FormShow(Sender: TObject);
    procedure WinListDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure BSelectClick(Sender: TObject);
    procedure WinListDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    hwnd:integer;
  end;

var
  PickWinForm: TPickWinForm;

implementation
uses Main;

{$R *.dfm}

var CapBuf:array[0..2047]of char;
function EWP(hwnd:THandle;lParam:integer):boolean; stdcall;
begin
  if IsWindowVisible(hwnd) then begin
    GetWindowText(hwnd,@CapBuf[0],2048); CapBuf[2047]:=#0;
    if (CapBuf[0]<>#0) then
      PickWinForm.WinList.Items.Add(toasc(hwnd)+string(PChar(@CapBuf[0])));
  end;
  EWP:=true;
end;

procedure TPickWinForm.FormShow(Sender: TObject);
begin
  WinList.Clear;
  EnumWindows(@EWP,0);
end;

procedure TPickWinForm.WinListDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  with WinList.Canvas do begin
    FillRect(Rect);
    TextOut(Rect.Left+2,Rect.Top,copy(WinList.Items[Index],9,256));
  end;
end;

procedure TPickWinForm.BSelectClick(Sender: TObject);
var i:integer; s:string[9];
begin
  i:=WinList.ItemIndex;
  if (i<0) OR (i>=WinList.Items.Count) then begin ModalResult:=mrCancel;exit;end;
  s:=copy(WinList.Items[i],1,8);
  hwnd:=((integer(s[1]) AND 15) SHL 28) OR ((integer(s[2]) AND 15) SHL 24) OR
        ((integer(s[3]) AND 15) SHL 20) OR ((integer(s[4]) AND 15) SHL 16) OR
        ((integer(s[5]) AND 15) SHL 12) OR ((integer(s[6]) AND 15) SHL  8) OR
        ((integer(s[7]) AND 15) SHL  4) OR  (integer(s[8]) AND 15);         
  ModalResult:=mrOK;
end;

procedure TPickWinForm.WinListDblClick(Sender: TObject);
begin
  BSelectClick(nil);
end;

end.
